#include "produkt1.h"
#include <string.h>
//****************************TProduk1********************

TProdukt1::TProdukt1(char* nazwa_,float cena_)
{
 cout<<"Konstruktor zwykly TProdukt1"<<endl;
 strcpy(nazwa,nazwa_);
 cena=cena_;
}

TProdukt1::TProdukt1(TProdukt1& p)
{
 cout<<"Konstruktor kopiujacy TProdukt1"<<endl;
 strcpy(nazwa,p.nazwa);
 cena=p.cena;
}

TProdukt1::~TProdukt1()
{
    cout<<"Destruktor TProdukt1"<<endl;
}

char* TProdukt1::Podaj_nazwa()
{
    return nazwa;
}

void TProdukt1::Nadaj_nazwa(char* nazwa_)
{
    strcpy (nazwa,nazwa_);
}

float TProdukt1::Podaj_cena()
{
    return cena;
} 

void TProdukt1::Nadaj_cena(float cena_)
{
    cena=cena_;
}

int TProdukt1::operator==(TProdukt1& p)
{
	return !strcmp(nazwa,p.nazwa) 
		    && cena==p.cena;
}

ostream& operator<<(ostream& a, TProdukt1& p)
{ return a<<"Nazwa: "<<p.nazwa<<
   " Cena: "<<setprecision(4)<<p.cena; 
}
//*********************TProdukt2**************************
//Konstruktor zwykly z lista argumentow
TProdukt2::TProdukt2(char* nazwa_,float cena_,float podatek_ ):
  TProdukt1(nazwa_, cena_), podatek(podatek_)
{
    cout<<"Konstruktor zwykly TProdukt2"<<endl; 
}
//Konstruktor kopiujacy z lista argumentow
TProdukt2::TProdukt2(TProdukt2& p):TProdukt1(p), podatek(p.podatek)
{
   cout<<"Konstruktor kopiujacy TProdukt2"<<endl;
}

TProdukt2::~TProdukt2()
{
   cout<<"Destruktor TProdukt2"<<endl;
}

float TProdukt2::Podaj_cena(int)
{
    return cena*(1+podatek/100);
}

float TProdukt2::Podaj_podatek()
{
    return podatek;
}

void TProdukt2::Nadaj_podatek(float podatek_)
{
    podatek=podatek_;
}

int TProdukt2::operator==(TProdukt2& p)
{   int a = TProdukt1::operator ==(p);
//wywolanie dziedziczonego od TProdukt1 przeciazonego operatora== 
//do porownania dziedziczonych atrybutow nazwa i cena
//p podstawione do tego operatora jest traktowane jak referencja
//do obiektu typu TProdukt1 (konwersja do referencji typu klasy bazowej)
    return a && podatek==p.podatek;
}

ostream& operator<<(ostream& a, TProdukt2& p)
{ TProdukt1& pom=p; 
//pom jest zmienna referencyjna typu TProdukt1 zdefiniowana przez 
//przypisane referencji obiektu nastepcy TProdukt2
//(dzieki konwersji referencji nastepcy TProdukt2 do referencji typu klasy bazowej TProdukt1)
//jest to lepsze rozwiazanie niz tworzenie obiektu TProdukt1
//za pomoca konstruktora kopiujacego
   a<<pom; //wywolanie przeciazonego operatora << klasy TProdukt1
   return a<<" Podatek: "<<p.podatek;
}